#!/usr/local/gauche/bin/gosh -I.

(define-module ffc
  (use www.cgi)
  (use srfi-27)
  (use srfi-19)
  (use text.html-lite)
  (use text.tree)
  (use srfi-1)
  (use rfc.cookie)
  (use file.util)
  (use srfi-13)
  (use srfi-14)
  (export ffc-expand-string))

(select-module ffc)

;
; "useful" tags
;
(define (make-url tokens)
  (if (null? tokens)
      #f
      (if (not (null? (cdr tokens)))
	  (format #f "<a href=\"~a\">~a</a>"
		  (car tokens)
		  (string-join (cdr tokens)))
	  (format #f "<a href=\"~a\">~a</a>" (car tokens) (car tokens)))))

(define (make-bold tokens)
  (if (null? tokens)
      #f
      (format #f "<b>~a</b>" (string-join tokens))))

(define (make-break) "<br />")
(define (make-br) "<br />")
(define (make-lb) "[")
(define (make-rb) "]")

(define (make-image tokens)
  (if (null? tokens)
      #f
      (format #f "<img src=\"~a\" />" (car tokens))))

;
; The quote tags.
;
(define (make-felix) "<em>I am the greatest scoutbomber when I'm over at your girlfriend's house, educating her with heated frictive lessons.</em>")
(define (make-pacino) "<b><em>FUCK YOU</em></b>")
(define (make-arnold) "<em>Who is your daddy and what does he do?</em>")
(define (make-stormy) "<em>I'm like a little otter.  A sexy little otter.</em>")
(define (make-stormy2) "<em>I'm like a little beaver.  A hot little beaver.</em>")
(define (make-bender) "<em>Bodies are for hookers and fat people.</em>")
(define (make-maddox) "<em>Nobody cares.</em>")
(define (make-beastyboys) "<em>I'm rockin' the mic in an old school way.</em>")
(define (make-beastyboys2) "<em>I'm like a pinch on the neck from Mr. Spock.</em>")

;
; expand-expression
;
; turn a FFC expression into a string.
;
(define (expand-expression msg i len)
  (let* ((tokens (string-tokenize msg char-set:graphic (+ i 1) (- len 1)))
	 (rv
	  (cond
	   ((string=? (car tokens) "url")    (make-url (cdr tokens)))
	   ((string=? (car tokens) "bold")   (make-bold (cdr tokens)))
	   ((string=? (car tokens) "pacino") (make-pacino))
	   ((string=? (car tokens) "arnold") (make-arnold))
	   ((string=? (car tokens) "break")  (make-break))
	   ((string=? (car tokens) "br")     (make-br))
	   ((string=? (car tokens) "lb")     (make-lb))
	   ((string=? (car tokens) "rb")     (make-rb))	   
	   ((string=? (car tokens) "felix")  (make-felix))	   
	   ((string=? (car tokens) "stormy") (make-stormy))
	   ((string=? (car tokens) "stormy2") (make-stormy2))
	   ((string=? (car tokens) "maddox") (make-maddox))
	   ((string=? (car tokens) "bender") (make-bender))
	   ((string=? (car tokens) "image")  (make-image (cdr tokens)))
	   ((string=? (car tokens) "beastyboys") (make-beastyboys))
	   ((string=? (car tokens) "beastyboys2") (make-beastyboys2))
	   (#t                               (substring/shared msg i len)))))
    (if (boolean? rv)
	(substring/shared msg i len)
	rv)))

;
; ffc-gobble-expression
;
; returns 2 values.  the index after the expression and the string resulting
; from the evaluation of the expression.
;
(define (ffc-gobble-expression msg i len)
  (let loop ((j  (+ i 1))
	     (c  0))
    
    (set! c (string-ref msg j))
    
    (if (char=? c #\])
	(values (+ j 1) (expand-expression msg i (+ j 1)))
	(if (< (+ j 1) len)
	    (loop (+ j 1) 0)
	    (values (+ j 1) (substring/shared msg i len))))
    )
  )

(define (ffc-expand-string msg)
  (let ((len (string-length msg))   ; length of the message string
	(sl  '())                   ; string list
	(esc #f)                    ; last character was the escape char
                                    ; escape character currently not set
	(c   0)                     ; current character
	(lo  #f))                   ; last ordinary character
    (let loop ((i   0))             ; current msg character index
      
      (set! c (string-ref msg i))

      (cond
       ((and (not esc) (char=? c #\[))
	(begin    ; if not escaped and a bracket then do this stuff
	  (if (number? lo)
	      (begin
		(set! sl (cons (substring/shared msg lo i) sl))
		(set! lo #f)))
	  (receive (newi es) (ffc-gobble-expression msg i len)
		   (set! sl (cons es sl))
		   (set! i (- newi 1)))))  ; step back 1 after the expression
                                           ; because at the end of the loop
                                           ; we do i + 1

       ((char=? c #\newline)
 	(begin    ; if a line feed then do this stuff
 	  (if (number? lo)
 	      (begin
 		(set! sl (cons (substring/shared msg lo i) sl))
 		(set! lo #f)))
 	  (let ((es      (expand-expression "[br]" 0 4)))
 	    (set! sl (cons es sl)))))
       
       (else (begin ; every other character
	       (if (boolean? lo) (set! lo i)) (set! esc #f))))
      
      (if (< (+ i 1) len)
	  (loop (+ i 1))
	  (begin
	    (if (number? lo)
		(set! sl (cons (substring/shared msg lo len) sl)))))
      )
    (string-join (reverse sl))
    )
  )

(provide "ffc")
