#!/local/gauche/bin/gosh -I.

(define-module userdb
  (use file.util)
  (use srfi-1)
  (use srfi-13)
  (use rfc.822)
  (use rfc.sha1)
  (export userdb-get-db userdb-save-user))

(select-module userdb)

(define (db-filter e)
  (string-suffix? ".pwl" e))

(define (userdb-get-db directory)
  (let ((pwls (directory-list directory
			      :children? #t :add-path? #t
			      :filter db-filter))
	(uplist '()))
    (for-each
     (lambda (file)
       (set! uplist
	     (cons (rfc822-header->list (open-input-file file)) uplist)))
     pwls)
    uplist))

(define (userdb-save-user ulist directory)
  (let ((username (cadr (assoc "username" ulist))))
    (with-output-to-file (format #f "~a/~a.pwl" directory
				 (digest-hexify
				  (sha1-digest-string username)))
      (lambda ()
	(for-each
	 (lambda (n)
	   (print (car n) ":" (cadr n)))
	 ulist)))
    ))

(provide "userdb")
